#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module RGUI
  class Button < Widget
    def initialize(gc, name='button', width=40, height=20)
      super(gc)
      @name = name
      @width, @height = width, height
      @act  = false
      @drag = false
    end
    attr :name
    attr :act
    attr :drag
    
    def layout
      _exposed
    end
    
    def _motion_notify(e)
      if @x < e.x && e.x < @x + @width && @y < e.y && e.y < @y + @height
        return if @act
        @act  = true
        _exposed
      else
        return unless @act
        @act  = false
        @drag = false
        _exposed
      end
    end
    
    def _button_press(e)
      return if @drag
      @drag = true
      _exposed
    end
    
    def _button_release(e)
      return unless @drag
      @drag = false
      _exposed
      clicked
    end
    
    def _exposed(e=nil)
      @gc.draw_button self
    end
    
    def clicked
    end
  end
end
