#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

require 'wide'
require 'xlib/keysym'

module RGUI
  class Entry < Widget
    def initialize(gc,text='',x=0,y=0,width=80,height=20)
      super(gc)
      @win = @gc.window
      @text = text
      @x,@y,@width,@height = x,y,width,height
      set_im_area
    end
    attr :text
  
    def text=(text); @text = text; exposed; end
  
    def layout; exposed; end
  
    def button_press(e)
      @win.focus_widget = self
      set_im_area
    end
  
    def key_press(e)
      return unless @focus
      @gc.draw_cursor self,:hide
      if e.string
        @gc.draw_text self, e.string
        @text << e.string
      else
        case e.keysym
        when Xlib::Keysym.intern('Return')
          entered
        when Xlib::Keysym.intern('BackSpace')
          wide = Wide::wide_at @text, @text.length-1
          @text = @text[0..(-2-wide)] || ""
        when Xlib::Keysym.intern('Shift_L')
        when Xlib::Keysym.intern('Shift_R')
        when Xlib::Keysym.intern('Control_L')
        when Xlib::Keysym.intern('Control_R')
        else
          print "#{type} unknown keysym: #{e.keysym}\n"
        end
      end
      exposed
    end
  
    def set_im_area
      begin
        @win.im.edit = Xlib::Point.new @x + FontWidth * @text.length, @y + FontSize
        @win.im.stat = Xlib::Rect .new @x + FontWidth * @text.length, @y + FontSize + FontDec, StatWidth, FontSize
      rescue
        p $!
      end
    end
  
    def exposed(e=nil)
      @gc.repaint self
      set_im_area
    end
  end
end
