#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

class ButtonGC < Xlib::GraphicContext
   def initialize
      @fg_color = display.alloc_color 'black'
      @bg_color = display.alloc_color 'gray'
      @bright_color = display.alloc_color 'white'
      @shadow_color = display.alloc_color 'dim gray'
      @active_color = display.alloc_color 'misty rose'
   end

   def draw_button(b)
      self.fg = if b.act then @active_color else @bg_color end
      fill_oval 0, 0, b.width  - 1, b.height - 1, 0,360*64

      # draw high light
      self.fg = @bright_color
      draw_oval 0, 0, b.width  - 1, b.height - 1, 120*64,60*64

      # draw shadow
      self.fg = @shadow_color
      draw_oval 0, 0, b.width  - 1, b.height - 1, 300*64,60*64

      # draw caption
      self.fg = @fg_color
      draw_string b.name, 3, b.height/2 + 3
   end
end
