#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

require 'xlib'
require 'rgui/rgui'
require 'rgui/feel/simple/button'
require 'rgui/feel/simple/frame'
require 'rgui/feel/simple/label'
require 'rgui/feel/simple/entry'
require 'rgui/feel/simple/panel'
require 'rgui/feel/simple/text'
require 'rgui/feel/simple/scroll'

module RGUI

  DIS = Xlib::Display.new

  def new_window(w=320,h=200,resizable=nil)
    win = RGUI::Window.new DIS.root,w,h,nil,resizable
    win.pixel = DIS.alloc_color 'gray'
    win.extend RGUI_simple
    win
  end
  module_function :new_window

  def loop
    DIS.flush
    while DIS.event; end
  end
  module_function :loop

end

module RGUI_simple

  def new_button(name,width=40,height=20)
    RGUI::Button.new ButtonGC.new(self),name,width,height
  end

  def new_frame(name,width=80,height=80)
    RGUI::Frame.new FrameGC.new(self),name,width,height
  end

  def new_label(text)
    RGUI::Label.new LabelGC.new(self),text
  end

  def new_entry
    RGUI::Entry.new EntryGC.new(self)
  end

  def new_panel(width=80,height=80)
    RGUI::Panel.new PanelGC.new(self),width,height
  end

  def new_text
    RGUI::Text.new TextGC.new(self)
  end

  def new_scroll(src)
    RGUI::Scroll.new ScrollGC.new(self),src,ButtonGC.new(self)
  end

end
