#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

class ButtonGC < Xlib::GraphicContext
  def initialize(win)
    super
    @text_color = display.alloc_color 'black'
    @back_color = display.alloc_color 'gray'
    @bright_color = display.alloc_color 'white'
    @shadow_color = display.alloc_color 'dim gray'
    @active_color = display.alloc_color 'misty rose'
  end

  def draw_button(b)
    self.fg = if b.act then @active_color else @back_color end
    fill_rect b.x, b.y, b.width-1, b.height-1
    # draw high light
    self.fg = if b.drag then @shadow_color else @bright_color end
    draw_line b.x, b.y, b.x + b.width-1, b.y
    draw_line b.x, b.y, b.x, b.y + b.height-1
    # draw shadow
    self.fg = if b.drag then @bright_color else @shadow_color end
    draw_line b.x, b.y + b.height-1, b.x + b.width-1, b.y + b.height-1
    draw_line b.x + b.width-1, b.y, b.x + b.width-1, b.y + b.height-1
    # draw caption
    self.fg = @text_color
    draw_str b.name, b.x + (b.width-b.name.length*RGUI::FontWidth)/2, b.y + b.height/2 + RGUI::FontSize/2-RGUI::FontDec
  end
end
