#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

class EntryGC < Xlib::GraphicContext
  FontSize  = RGUI::FontSize
  FontWidth = RGUI::FontWidth
  FontDec   = RGUI::FontDec

  def initialize(win)
    @clear_color = display.alloc_color 'white'
    @cursor_color = display.alloc_color 'dim gray'
    @text_color = display.alloc_color 'black'
    self.bg = @clear_color
  end

  def clear(a)
    self.fg = @clear_color
    fill_rect a.x,a.y,a.width,a.height
  end

  def draw_cursor(a,mode)
    self.fg = case mode
    when :show; @cursor_color
    when :hide; @clear_color
    end
    fill_rect a.x + FontWidth * a.text.length, a.y + FontDec, FontWidth, FontSize
  end

  def draw_text(a,s)
    self.fg = @text_color
    draw_str s, a.x + FontWidth * a.text.length, a.y + FontSize
  end

  def repaint(a)
    clear a
    self.fg = @text_color
    draw_str a.text, a.x, a.y + FontSize
    draw_cursor a,:show
  end
end
