#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

require 'wide'

class TextGC < Xlib::GraphicContext
  FontSize  = RGUI::FontSize
  FontWidth = RGUI::FontWidth
  FontDec   = RGUI::FontDec

  def initialize(win)
    super
    @win = win
    @back_color = display.alloc_color 'white'
    @text_color = display.alloc_color 'black'
    @cursor_color = display.alloc_color 'dim gray'
    self.bg = @back_color
  end

  def draw_cursor(a,mode)
    drawable = window
    self.window = @win
    self.fg = case mode
    when :show; @cursor_color
    when :hide; @back_color
    end
    draw_rect a.x + FontWidth * (a.col - a.scrx / FontWidth),
              a.y + FontSize  * (a.row - a.scry / FontSize ) + FontDec,
              0,
              FontSize
    self.window = drawable
  end

  def repaint(a)
    self.fg = @back_color
    fill_rect 0, 0, a.width, a.height
    self.fg = @text_color
    colmin = a.scrx / FontWidth
    rowmin = a.scry / FontSize
    colmax = a.cols
    rowmax = a.rows
    a.ary[rowmin..rowmax].each_with_index { |string, row|
      last = if string.length-1<colmax then string.length-1 else colmax end
      next if last<colmin
      wide = Wide::wide_at string, colmin
      draw_str string[(colmin+wide)..last], wide*FontWidth, (row+1)*FontSize
    }
  end
end
