#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module RGUI
  class Hbox < Widget
    include RGUI
  
    def initialize(homo,space,fill,vdir=:n,hdir=:w)
      super(nil)
      @homo = homo
      @space = space
      @fill = fill
      @vdir = vdir
      @hdir = hdir
    end
  
    def layout
      return if @childlen.empty?
      max_w = 0
      max_h = 0
      @childlen.each { |c|
        max_w = c.width  if max_w < c.width
        max_h = c.height if max_h < c.height
      }
      @childlen.each { |c|
        c.width  = max_w
        c.height = max_h
      } if @homo
      sum_w = 0
      @childlen.each { |c|
        sum_w += c.width
      }
      w = @width - @space; w=1 if w<1
      mean_h = @height - @space*2; mean_h=1 if mean_h<1
      x = (w % @childlen.size)/2 + @space
      x = @width - x if @hdir == :e
      @childlen.each { |c|
        n = c.width * w / sum_w - @space; n=1 if n<1
        c.width  = n
        c.height = mean_h
      } if @fill
      @childlen.each { |c|
        case @hdir
        when :w
          c.x = @x+x
          x += @space + c.width
        when :e
          c.x = @x+x-c.width
          x -= @space + c.width
        end
        case @vdir
        when :n
          c.y = @y+@space
        when :s
          c.y = @y+@height-(@space+c.height)
        end
        c.layout
      }
    end
  end
end
