#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module RGUI
  class Vbox < Widget
    include RGUI
  
    def initialize(homo,space,fill,vdir=:n,hdir=:w)
      super(nil)
      @homo = homo
      @space = space
      @fill = fill
      @vdir = vdir
      @hdir = hdir
    end
    attr :x,true
    attr :y,true
    attr :width ,true
    attr :height,true
  
    def layout
      return if @childlen.empty?
      max_w = 0
      max_h = 0
      @childlen.each { |c|
        max_w = c.width  if max_w < c.width
        max_h = c.height if max_h < c.height
      }
      @childlen.each { |c|
        c.width  = max_w
        c.height = max_h
      } if @homo
      sum_h = 0
      @childlen.each { |c|
        sum_h += c.height
      }
      h = @height - @space; h=1 if h<1
      mean_w = @width - @space*2; mean_w=1 if mean_w<1
      y = (h % @childlen.size)/2 + @space
      y = @height - y if @vdir == :s
      @childlen.each { |c|
        c.width  = mean_w
        n = c.height * h / sum_h - @space; n=1 if n<1
        c.height = n
      } if @fill
      @childlen.each { |c|
        case @hdir
        when :w
          c.x = @x+@space
        when :e
          c.x = @x+@width-(@space+c.width)
        end
        case @vdir
        when :n
          c.y = @y+y
          y += @space + c.height
        when :s
          c.y = @y+y-c.height
          y -= @space + c.height
        end
        c.layout
      }
    end
  end
end
