#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module RGUI
  class Window < Xlib::Window
    include RGUI
    
    def initialize(*args)
      super(*args)
      edit = Xlib::Point.new 0, 0
      stat = Xlib::Rect .new 0, 0, StatWidth, FontSize
      begin
        @im = new_im true, edit, stat
      rescue
        p $!
        @im = nil
      end
      @focus_widget = nil
      show
    end
    attr :im
    attr :focus_widget,true
    
    def layout
      clear
      @childlen.each { |c|
        c.x = 0
        c.y = 0
        c.width  = width
        c.height = height
        c.layout
      }
    end
    
    def focus_widget=(c)
      return unless c.is_a? Widget
      @focus_widget.focus = false if @focus_widget.is_a? Widget
      c.focus = true
      @focus_widget = c
    end
    
    def exposed(e) layout end

    def modal
      begin
        while display.event(self)
        end
        close
      rescue
        p $!
      end
    end

  end
end
